<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">  

<xsl:template match="/">
     <xsl:apply-templates/>
</xsl:template>

<xsl:template match="*">
     <xsl:apply-templates/>
</xsl:template>

<xsl:template match="doc">
 <html>
   <head>
     <title>
       <xsl:value-of select="title"/>
     </title>
   </head>
   <body>
     <xsl:apply-templates/>
   </body>
 </html>
</xsl:template>

<xsl:template match="doc/title">
  <h1>
    <xsl:value-of select="."/>
  </h1>
</xsl:template>

<xsl:template match="chapter/title">
  <h2>
    <xsl:value-of select="."/>
    
  </h2>
</xsl:template>

<xsl:template match="section/title">
  <h3>
    <xsl:value-of select="."/>
  </h3>
</xsl:template>

<xsl:template match="para">
  <p>
    <xsl:value-of select="."/>
  </p>
</xsl:template>

<xsl:template match="note">
  <p class="note">
    <b>NOTE: </b><xsl:value-of select="."/>
  </p>
</xsl:template>

<xsl:template match="emph">
  <em>
    <xsl:value-of select="."/>
  </em>
</xsl:template>

</xsl:stylesheet>