
// FAQ of JavaScript
// see http://developer.netscape.com/tech/dynhtml/dynhtml.html

//
// class List
//

function List_addElement(e){
	this[this.len]=e;
	this.len++;
}

function List_sortAscBy(attribute){
	// Bubble Sort
	var l=this.len - 1;
	var i=0;
	var j=0;
	var e1;
	var e2;
	for(i=0;i<l;i++) {
	  for(j=0;j<l-i;j++) {
		e1=this[j];
		e2=this[j+1];
		if(e1[attribute] > e2[attribute]) {
			this[j]=e2;
			this[j+1]=e1;
		}
	  }	
	}
}
function List_sortDescBy(attribute){
	// Bubble Sort
	var l=this.len - 1;
	var i=0;
	var j=0;
	var e1;
	var e2;
	for(i=0;i<l;i++) {
	  for(j=0;j<l-i;j++) {
		e1=this[j];
		e2=this[j+1];
		if(e1[attribute] < e2[attribute]) {
			this[j]=e2;
			this[j+1]=e1;
		}
	  }	
	}
}

function List_getAttributeList(attribute){
	var i;
	var e;
	var a;
	var l;
	for(i=0;i<this.len;i++) {
		e=this[i];
		a=e[attribute];
		if(a!=null) {
			if(l==null) { l= new List(); }
			if(l.search(a)==false) { l.addElement(a); }
			//l.addElement(a);
		}
	}
	return l;
}


function List_indexOf(element,startIndex){
	var i=0;
	if(startIndex!=null) { i=startIndex; }
	for(;i<this.len;i++) {
		if(this[i]==element) { return i; }
	}
	return -1;
}

function List_indexOfByAttribute(attribute,valueOfAttribute,startIndex){
	var i;
	var e;
	var a;
	if(startIndex==null) { i=0; } else { i=startIndex; }
	for(;i<this.len;i++) {
		e=this[i];
		a=e[attribute];
		if(a==valueOfAttribute) { return i; }
	}
	return -1;
}

function List_search(element){
	return (this.indexOf(element,null)!=-1);
}

function List_searchByAttribute(attribute,valueOfAttribute){
	return (this.indexOfByAttribute(attribute,valueOfAttribute,null)!=-1);
}

function List(){
	// attributes
	this.len=0;

	// methods
	this.addElement=List_addElement;

	this.sortAscBy=List_sortAscBy;
	this.sortDescBy=List_sortDescBy;

	this.getAttributeList=List_getAttributeList;

	this.search=List_search;
	this.searchByAttribute=List_searchByAttribute;
	this.indexOf=List_indexOf;
	this.indexOfByAttribute=List_indexOfByAttribute;

	return this;
}

//
// class Publication
//

function Publication_printXML(doc){
	doc.writeln("<publication>");
	/*for(i in this) {
		a=this[i];
		if(a==null) {
			doc.writeln("<"+i+"/>");
		}else{
			doc.writeln("<"+i+">"+a+"<"+i+"/>");
		}
	}
	*/
	doc.writeln("<author>" + this.author + "</author>");
	doc.writeln("<title>" + this.title + "</title>");
	doc.writeln("<place>" + this.place + "</place>");
	doc.writeln("<date year=\'" + this.year + "\'/>");
	
	doc.writeln("</publication>\n");
}

function Publication_printHTML(doc) {
	doc.writeln("<P><FONT SIZE=-1>");

	if(this.author!=null) {
		doc.writeln( this.author );
	}

	if(this.title!=null) {
		doc.writeln("<BR><B>" + this.title + "</B>");
	}

	if(this.date!=null) {
		doc.writeln("<BR><I>" + this.date + "</I>");
	}

	if(this.place!=null) {
		doc.writeln("<I>&nbsp;&nbsp;&nbsp;&nbsp;" + this.place + "</I>");
	}

	doc.writeln("</FONT></P>");

	doc.writeln("<P CLASS='comment'>");

	if(this.area!=null) {
		doc.writeln("Mot-cls:" + this.area+"<BR>");
	}

	if(this.email!=null) {
		doc.write("Email: <A HREF=\'mailto:" + this.email + "\'>")
		doc.write(this.email);
		doc.writeln("</A><BR>");
	}
	if(this.homepage!=null) {
		doc.write("Page personnelle: <A HREF=\'" + this.homepage + "\' TARGET=_top>")
		doc.write(this.homepage);
		doc.writeln("</A><BR>");

	}

	if(this.resume!=null) {
		doc.write("Rsum:<BR>" + this.resume)
		doc.writeln("<BR>");

	}
		
	doc.writeln("</P>\n");
}

function Publication_printBibTex(doc){
	doc.writeln("Publication_printBibTex not implemented !");
}

function Publication_print(doc, typeOutput){
	switch(typeOutput) {
		case "HTML" :	this.printHTML(doc); return;
		case "XML" :	this.printXML(doc); return;
		case "BibTex" :	this.printBibTex(doc); return;
	}
	doc.writeln("Publication_print : typeOutput '"+ typeOutput +"' not implemented !");
}


function Publication_matches(attribute,substr){
	a=this[attribute];
	if(a==null) { return false; }
	pos=a.indexOf(substr);
	if(pos==-1) {
		return false;
	}
	return true;
}

function Publication_contains(substr){
	/*
	// search in all attributes
	for(i in this){
		if(this.matches(i,substr) { return true; }
	}
	return false;
	*/
	
	// search in author or title attributes
	return this.matches("author",substr) || this.matches("title",substr);
}

function Publication(){
	// attributes
	this.author=null;
	this.title=null;
	this.place=null;
	this.area=null;
	this.date=null;
	this.year=null;
	this.homepage=null;
	this.email=null;
	this.resume=null;
	
	// methods
	this.print=Publication_print;
	this.printXML=Publication_printXML;
	this.printHTML=Publication_printHTML;
	this.printBibTex=Publication_printBibTex;


	this.matches=Publication_matches;
	this.contains=Publication_contains;

	return this;
}

//
// Global functions
//

function ListPublications_Head(doc,typeOutput){
	switch(typeOutput){
	case "HTML" :
		doc.open("text/html","replace");
		doc.write(
			"<HTML><HEAD>"
		+	"<LINK REL=STYLESHEET TYPE='text/css' HREF='style.css'>"
		+	"<META HTTP-EQUIV='Content-Type' CONTENT='text/html; charset=iso-8859-1'>"
   		+	"<TITLE>LAMIH - Seminaires Informatiques</TITLE>"
		+	"</HEAD>"
		+	"<BODY class='index'>"
		);
		break;
	case "XML" : 
//		doc.open("text/xml","replace");
		doc.open("text/plain","replace");
		doc.writeln(
			"<?xml version=\"1.0\"?>"
		//+	"<?xml-stylesheet type='text/xsl' href='xml2html.xsl'?>"
		);
		doc.writeln(
			"<PUBLICATIONS>"
		);
		break;
	default:
		doc.open("text/plain","replace");	
	}
}

function ListPublications_Tail(doc,typeOutput){
	switch(typeOutput){
	case "HTML" : 	
		doc.write(
			"</BODY>"
		+	"</HTML>"
		);
		break;
	case "XML" :
		doc.write(
			"</PUBLICATIONS>"
		);
		break;
	default:
		//
	}
}

function ListPublicationsByYear(doc,pubs,typeOutput){
	var i;
	var listatt;
	// header
	
	ListPublications_Head(doc,typeOutput)

	pubs.sortDescBy("year");	

	// body - part ToC
	if(typeOutput=="HTML") {
		doc.writeln("<UL>");
		listatt=pubs.getAttributeList("year");
		if(listatt!=null) {
		    for(i=0;i<listatt.len;i++){
			doc.writeln("<LI>"+ listatt[i] + "</LI>");
		    }
		}
		doc.writeln("</UL><HR>");
	}

	// body - part Publications

	for(i=0;i<pubs.len;i++){
		pubs[i].print(doc,typeOutput);
	}

	// tail
	ListPublications_Tail(doc,typeOutput)
	doc.close();
	return;
}

function ListPublicationsByArea(doc,pubs,typeOutput){
	var i;	// header
	var listatt;
	ListPublications_Head(doc,typeOutput)

	pubs.sortAscBy("area");

	// body - part ToC
	if(typeOutput=="HTML") {
		doc.writeln("<UL>");
		listatt=pubs.getAttributeList("area");
		for(i=0;i<listatt.len;i++){
			doc.writeln("<LI>"+ listatt[i] + "</LI>");
		}
		doc.writeln("</UL><HR>");
	}

	// body - part Publications
	for(i=0;i<pubs.len;i++){
		pubs[i].print(doc,typeOutput);
	}

	// tail
	ListPublications_Tail(doc,typeOutput)
	doc.close();
	return;
}

function ListPublicationsByAuthor(doc,pubs,typeOutput){
	var i;
	var listatt;

	// header
	ListPublications_Head(doc,typeOutput)

	pubs.sortAscBy("type");

	// body - part ToC
	if(typeOutput=="HTML") {
		doc.writeln("<UL>");
		listatt=pubs.getAttributeList("author");
		for(i=0;i<listatt.len;i++){
			doc.writeln("<LI>"+ listatt[i] + "</LI>");
		}
		doc.writeln("</UL><HR>");
	}


	// body - part Publications
	for(i=0;i<pubs.len;i++){
		pubs[i].print(doc,typeOutput);
	}

	// tail
	ListPublications_Tail(doc,typeOutput)
	doc.close();
	return;
}

function ListPublicationsByKeyword(doc,pubs,typeOutput,keyword){
	// header
	ListPublications_Head(doc,typeOutput)

	// body - part Publications
	for(i=0;i<pubs.len;i++){
		if(pubs[i].contains(keyword)) {
			pubs[i].print(doc,typeOutput);
		}
	}

	
	// body
/*
	var startIndex=0;
	while(startIndex!=-1){
		startIndex=pubs[i].indexOfByAttribute(attribute,keyword,startIndex);
		if(startIndex!=-1) {
			pubs[startIndex].print(doc,typeOutput);
			startIndex+=1;
		} else {
			break;
		}
	}
*/
	// tail
	ListPublications_Tail(doc,typeOutput)
	doc.close();
	return;
}
